/*
 * main.c
 *
 *  Created on: Sep 11, 2018
 *      Author: joseppi
 */


#include <cstdlib>
#include <gst/gst.h>
#include <gst/gstinfo.h>
#include <gst/app/gstappsink.h>
#include <glib-unix.h>
#include <dlfcn.h>
#include <iostream>
#include <sstream>
#include <thread>

using namespace std;

#define USE(x) ((void)(x))

static GstPipeline *gst_pipeline = nullptr;
static string launch_string;

int main(int argc, char** argv) {
    USE(argc);
    USE(argv);

    gst_init (&argc, &argv);

    GMainLoop *main_loop;
    GstState old_state, new_state;
    main_loop = g_main_loop_new (NULL, FALSE);
    ostringstream launch_stream;
    int w = 800;
    int h = 600;
    //GstAppSinkCallbacks callbacks = {appsink_eos, NULL, new_buffer};

    launch_stream  << "videotestsrc ! "
    << "video/x-raw, width="<< w <<", height="<< h <<", format=(string)I420 ! "
    << "omxh264enc profile=1 insert-sps-pps=true ! "
    << "video/x-h264, stream-format=(string)byte-stream ! "
    << "h264parse config-interval=1 ! "
    << "splitmuxsink location=/home/nvidia/test-%02d.avi muxer=avimux max-files=5 max-size-time=60000000000 ";

    launch_string = launch_stream.str();

    g_print("Using launch string: %s\n", launch_string.c_str());

    GError *error = nullptr;
    gst_pipeline  = (GstPipeline*) gst_parse_launch(launch_string.c_str(), &error);

    if (gst_pipeline == nullptr) {
        g_print( "Failed to parse launch: %s\n", error->message);
        return -1;
    }
    if(error) g_error_free(error);

    gst_element_set_state((GstElement*)gst_pipeline, GST_STATE_PLAYING);
    sleep(20);
    gst_element_set_state((GstElement*)gst_pipeline, GST_STATE_NULL);
    sleep(5);
    g_print("Starting 2nd time: \n");
    gst_element_set_state((GstElement*)gst_pipeline, GST_STATE_PLAYING);
    sleep(2);
    gst_element_get_state((GstElement*)gst_pipeline, &old_state, &new_state, GST_CLOCK_TIME_NONE);
    g_print("Pipeline state after second start: %s %s\n", gst_element_state_get_name(old_state), gst_element_state_get_name(new_state));
    sleep(12);

    gst_element_set_state((GstElement*)gst_pipeline, GST_STATE_NULL);


    gst_object_unref(GST_OBJECT(gst_pipeline));
    g_main_loop_unref(main_loop);

    g_print("going to exit \n");
    return 0;
}

